Exec (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.taskdefs, class: Exec

# Class Exec

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.Task
org.apache.tools.ant.taskdefs.Exec

All Implemented Interfaces:
  `Cloneable`

@Deprecated public class Exec extends Task
Deprecated.
since 1.2. delegate to `Execute` instead.
Executes a given command if the os platform is appropriate.

As of Ant 1.2, this class is no longer the implementation of Ant's <exec> task - it is considered to be dead code by the Ant developers and is unmaintained. Don't use it.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected PrintWriter`
  `fos`
  Deprecated.

  ### Fields inherited from class Task

  `target, taskName, taskType, wrapper`
  Modifier and Type
  Field
  Description
  `protected Target`
  `target`
  Deprecated.
  since 1.6.x.
  `protected String`
  `taskName`
  Deprecated.
  since 1.6.x.
  `protected String`
  `taskType`
  Deprecated.
  since 1.6.x.
  `protected RuntimeConfigurable`
  `wrapper`
  Deprecated.
  since 1.6.x.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Exec()`
  Deprecated.
  Constructor for Exec.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `execute()`
  Deprecated.
  Execute the task.
  `protected void`
  `logFlush()`
  Deprecated.
  Close output.
  `protected void`
  `outputLog(String line, int messageLevel)`
  Deprecated.
  Log an output message.
  `protected int`
  `run(String command)`
  Deprecated.
  Execute the command.
  `void`
  `setCommand(String command)`
  Deprecated.
  Set the command to exec.
  `void`
  `setDir(String d)`
  Deprecated.
  Set the directory.
  `void`
  `setFailonerror(boolean fail)`
  Deprecated.
  Set the failOnError attribute.
  `void`
  `setOs(String os)`
  Deprecated.
  Set the Operating System that this exec is to run in.
  `void`
  `setOutput(String out)`
  Deprecated.
  Set the output filename.

  ### Methods inherited from class Task

  `bindToOwner, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, getTaskType, getWrapper, handleErrorFlush, handleErrorOutput, handleFlush, handleInput, handleOutput, init, isInvalid, log, log, log, log, maybeConfigure, perform, reconfigure, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName, setTaskType`
  Modifier and Type
  Method
  Description
  `final void`
  `bindToOwner(Task owner)`
  Bind a task to another; use this when configuring a newly created task to do work on behalf of another.
  `Target`
  `getOwningTarget()`
  Returns the container target of this task.
  `RuntimeConfigurable`
  `getRuntimeConfigurableWrapper()`
  Returns the wrapper used for runtime configuration.
  `String`
  `getTaskName()`
  Returns the name to use in logging messages.
  `String`
  `getTaskType()`
  Return the type of task.
  `protected RuntimeConfigurable`
  `getWrapper()`
  Return the runtime configurable structure for this task.
  `protected void`
  `handleErrorFlush(String output)`
  Handles an error line by logging it with the WARN priority.
  `protected void`
  `handleErrorOutput(String output)`
  Handles an error output by logging it with the WARN priority.
  `protected void`
  `handleFlush(String output)`
  Handles output by logging it with the INFO priority.
  `protected int`
  `handleInput(byte[] buffer, int offset, int length)`
  Handle an input request by this task.
  `protected void`
  `handleOutput(String output)`
  Handles output by logging it with the INFO priority.
  `void`
  `init()`
  Called by the project to let the task initialize properly.
  `protected final boolean`
  `isInvalid()`
  Has this task been marked invalid?
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `log(String msg, Throwable t, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `log(Throwable t, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `maybeConfigure()`
  Configures this task - if it hasn't been done already.
  `final void`
  `perform()`
  Performs this task if it's still valid, or gets a replacement version and performs that otherwise.
  `void`
  `reconfigure()`
  Force the task to be reconfigured from its RuntimeConfigurable.
  `void`
  `setOwningTarget(Target target)`
  Sets the target container of this task.
  `void`
  `setRuntimeConfigurableWrapper(RuntimeConfigurable wrapper)`
  Sets the wrapper to be used for runtime configuration.
  `void`
  `setTaskName(String name)`
  Sets the name to use in logging messages.
  `void`
  `setTaskType(String type)`
  Sets the name with which the task has been invoked.

  ### Methods inherited from class ProjectComponent

  `clone, getDescription, getLocation, getProject, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### fos

    protected PrintWriter fos
    Deprecated.

- ## Constructor Details

  - ### Exec

    public Exec()
    Deprecated.
    Constructor for Exec. Prints a warning message to std error.

- ## Method Details

  - ### execute

    public void execute() throws BuildException
    Deprecated.
    Execute the task.
    Overrides:
      `execute` in class `Task`
    Throws:
      `BuildException` - on error

  - ### run

    protected int run(String command) throws BuildException
    Deprecated.
    Execute the command.
    Parameters:
      `command` - the command to exec
    Returns:
      the exit value of the command
    Throws:
      `BuildException` - on error

  - ### setDir

    public void setDir(String d)
    Deprecated.
    Set the directory.
    Parameters:
      `d` - a `String` value

  - ### setOs

    public void setOs(String os)
    Deprecated.
    Set the Operating System that this exec is to run in.
    Parameters:
      `os` - a `String` value

  - ### setCommand

    public void setCommand(String command)
    Deprecated.
    Set the command to exec.
    Parameters:
      `command` - a `String` value

  - ### setOutput

    public void setOutput(String out)
    Deprecated.
    Set the output filename.
    Parameters:
      `out` - a `String` value

  - ### setFailonerror

    public void setFailonerror(boolean fail)
    Deprecated.
    Set the failOnError attribute. Default is false.
    Parameters:
      `fail` - a `boolean` value

  - ### outputLog

    protected void outputLog(String line, int messageLevel)
    Deprecated.
    Log an output message.
    Parameters:
      `line` - the line to putput
      `messageLevel` - the level of logging - ignored if output is going to a file

  - ### logFlush

    protected void logFlush()
    Deprecated.
    Close output.